<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- @author fabio.navarrete

@modified pedro.garcia 
    10-07-2012 adición de atributo showChangeOrderLink
    14-07-2012 uso del atributo 'required'
-->
<!--
/*
Algún baboso puso el atributo 'required' que nunca se usaba
*/
-->
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>
        <composite:attribute name="label" required="true" />
        <composite:attribute name="valorDato" required="true" />
        <composite:attribute name="datosSelectItems" default="true" />
        <composite:attribute name="required" required="false" default="true"
                             shortDescription="define si el valor del combo es required"/>
        <composite:attribute name="renderValor" />
        <composite:attribute name="renderCombo" />
        <composite:attribute name="idCombo" />
        <composite:attribute name="orderByName" />
        <composite:attribute name="orderTitle" default="Orden" />
        <composite:attribute name="updateOnChange" />
        <composite:attribute name="geoComboId" required="false"
                             default="geoComboId" />
        <composite:attribute name="sortCodeImage"
                             default="/images/sortCode.png" />
        <composite:attribute name="sortTextImage"
                             default="/images/sortText.png" />

        <composite:attribute name="onChange" method-signature="void action()" />
        <composite:attribute name="onChangeGeoCombo"
                             method-signature="void action()" />
        <composite:attribute name="changeGeoComboOrder"
                             method-signature="void action()" />

        <composite:attribute name="showChangeOrderLink" default="true" required="false"
                             shortDescription="define si se muestra el link para cambiar el orden de los valores del combo" />

    </composite:interface>

    <composite:implementation>

        <h:outputText value="#{cc.attrs.valorDato}"
                      rendered="#{cc.attrs.renderValor}" />
        <h:panelGrid columns="3" rendered="#{cc.attrs.renderCombo}">
            <h:selectOneMenu id="#{cc.attrs.idCombo}" label="#{cc.attrs.label}"
                             required="#{cc.attrs.required}"
                             value="#{cc.attrs.valorDato}">
                <f:selectItems value="#{cc.attrs.datosSelectItems}" />
                <p:ajax listener="#{cc.attrs.onChange}" process="@this"
                        update="#{cc.attrs.updateOnChange}" />
            </h:selectOneMenu>

            <p:message for="#{cc.attrs.idCombo}" />
            <p:commandLink update="btnOrdenGeoCombo, #{cc.attrs.geoComboId}"
                           title="#{cc.attrs.orderTitle}"
                           action="#{cc.attrs.changeGeoComboOrder}" id="btnOrdenGeoCombo"
                           ajax="true" process="@this"
                           rendered="#{cc.attrs.showChangeOrderLink}">
                <p:graphicImage rendered="#{cc.attrs.orderByName}"
                                style="border: none" value="#{cc.attrs.sortCodeImage}" />
                <p:graphicImage rendered="#{!cc.attrs.orderByName}"
                                style="border: none" value="#{cc.attrs.sortTextImage}" />

            </p:commandLink>
        </h:panelGrid>

    </composite:implementation>

</html>